<?php
/**
 * The template for displaying all single posts.
 */
$mts_options = get_option(MTS_THEME_NAME);

get_header(); ?>

<div id="page" class="<?php mts_single_page_class(); ?>">

	<?php $check_sidebar = mts_custom_sidebar(); ?>


		<div id="content_box" >
			<?php if ( have_posts() ) while ( have_posts() ) : the_post(); ?>
				<div id="post-<?php the_ID(); ?>" <?php post_class('g post'); ?>>
					<div class="single-post-wrap">
						<article class="<?php mts_article_class(); ?>">
							<?php
							if ( '1' == $mts_options['mts_breadcrumb'] ) {
								mts_the_breadcrumb();
							}
							$header_animation = mts_get_post_header_effect(); ?>
								<?php if ( 'parallax' === $header_animation ) {?>
									<?php if (mts_get_thumbnail_url()) : ?>
										<div id="parallax" <?php echo 'style="background-image: url('.mts_get_thumbnail_url().');"'; ?>></div>
									<?php endif; ?>
								<?php } else if ( 'zoomout' === $header_animation ) {?>
									 <?php if (mts_get_thumbnail_url()) : ?>
										<div id="zoom-out-effect"><div id="zoom-out-bg" <?php echo 'style="background-image: url('.mts_get_thumbnail_url().');"'; ?>></div></div>
								<?php endif; ?>
							<?php } ?>
							<header>
								<div class="single-top-header">
									<?php mts_the_postinfo( 'single' ); ?>
									<?php if( $mts_options['mts_like_button'] ) { ?>
										<div class="mts-like">
											<?php echo get_simple_likes_button( get_the_ID() ); ?>
										</div>
									<?php } ?>
									<?php if( $mts_options['mts_show_views'] ) : ?>
										<div class="views">
							            	<?php $count = get_post_meta( get_the_id(), '_mts_view_count', true ); if ( $count )  echo '<i class="fa fa-eye"></i>' . ' ' . $count;  ?>
							            </div>
									<?php endif; ?>
								</div>
								<h1 class="title single-title entry-title"><?php the_title(); ?></h1>
							</header><!--.headline_area-->

							<?php // Top Social Share ?>
							<?php if (isset($mts_options['mts_social_button_position']) && $mts_options['mts_social_button_position'] == 'top') mts_social_buttons(); ?>

							<?php if ( has_post_thumbnail() && $mts_options['mts_single_featured_image'] ) : ?>
								<div class="single-featured-thumbnail">
									<?php if ( $check_sidebar == 'mts_nosidebar' ) {
										the_post_thumbnail('clean-full-slider',array('title' => ''));
									}
									else {
										 the_post_thumbnail('clean-featuredfull',array('title' => ''));
									} ?>
								</div>
							<?php endif; ?>
							<div class="post-single-content box mark-links entry-content">
								<?php // Top Ad Code ?>
								<?php if ($mts_options['mts_posttop_adcode'] != '') { ?>
									<?php $toptime = $mts_options['mts_posttop_adcode_time']; if (strcmp( date("Y-m-d", strtotime( "-$toptime day")), get_the_time("Y-m-d") ) >= 0) { ?>
										<div class="topad">
											<?php echo do_shortcode($mts_options['mts_posttop_adcode']); ?>
										</div>
									<?php } ?>
								<?php } ?>

								<?php // Content ?>
								<div class="thecontent">
									<?php the_content(); ?>
								</div>

								<?php // Single Pagination ?>
								<?php wp_link_pages(array('before' => '<div class="pagination">', 'after' => '</div>', 'link_before'  => '<span class="current"><span class="currenttext">', 'link_after' => '</span></span>', 'next_or_number' => 'next_and_number', 'nextpagelink' => '<i class="fa fa-angle-double-right"></i>', 'previouspagelink' => '<i class="fa fa-angle-double-left"></i>', 'pagelink' => '%','echo' => 1 )); ?>

								<?php // Bottom Ad Code ?>
								<?php if ($mts_options['mts_postend_adcode'] != '') { ?>
									<?php $endtime = $mts_options['mts_postend_adcode_time']; if (strcmp( date("Y-m-d", strtotime( "-$endtime day")), get_the_time("Y-m-d") ) >= 0) { ?>
										<div class="bottomad">
											<?php echo do_shortcode($mts_options['mts_postend_adcode']); ?>
										</div>
									<?php } ?>
								<?php } ?>

								<?php // Bottom Social Share ?>
								<?php if (isset($mts_options['mts_social_button_position']) && $mts_options['mts_social_button_position'] !== 'top') mts_social_buttons(); ?>
							</div><!--.post-single-content-->
						</article><!--.single_post-->
						<?php get_sidebar(); ?>
					</div>

					<!-- Single post parts ordering -->
					<?php if ( isset( $mts_options['mts_single_post_layout'] ) && is_array( $mts_options['mts_single_post_layout'] ) && array_key_exists( 'enabled', $mts_options['mts_single_post_layout'] ) ) {
						$single_post_parts = $mts_options['mts_single_post_layout']['enabled'];
					} else {
						$single_post_parts = array( 'related' => 'related', 'author' => 'author' );
					}
					foreach( $single_post_parts as $part => $label ) {
						switch ($part) {

							case 'tags':
								?>
								<?php mts_the_tags('<div class="tags"><span class="tagtext"><i class="fa fa-tags"></i></span>') ?>
								<?php
							break;

							case 'related':
								mts_related_posts();
							break;

							case 'author':
								?>
								<div class="postauthor">
									<h4><?php _e('About The Author', 'clean' ); ?></h4>
									<?php if(function_exists('get_avatar')) { echo get_avatar( get_the_author_meta('email'), '100' );  } ?>
									<h5 class="vcard author"><a href="<?php echo esc_url( get_author_posts_url( get_the_author_meta( 'ID' ) ) ); ?>" class="fn"><?php the_author_meta( 'display_name' ); ?></a></h5>
									<p><?php the_author_meta('description') ?></p>
								</div>
								<?php
							break;
						}
					} ?>
				</div><!--.g post-->
				<?php comments_template( '', true ); ?>
			<?php endwhile; /* end loop */ ?>
		</div>
<?php get_footer(); ?>
